futhark-0.25.32: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.Internalise.ApplyTypeAbbrs

Description

A minor cleanup pass that runs after defunctorisation and applies any type abbreviations. After this, the program consists entirely value bindings.

Synopsis

- transformProg :: Monad m => [Dec] -> m [ValBind]

# Documentation

transformProg :: Monad m => [Dec] -> m [ValBind] Source #

Apply type abbreviations from a list of top-level declarations. A module-free input program is expected, so only value declarations and type declaration are accepted.